/***************************************************************************
 *   Copyright (C) 2006 by André Lindhjem <belgarat@sdf.lonestar.org>,     *
 *                         Kjetil Holien <kjetil.holien@gmail.com>,        *
 *                         Terje Risa <terje.risa@gmail.com> &             *
 *                         Øyvind Nerbråten <oyvind@nerbraten.com>         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************
 *
 * \file daisylibao.h
 * \author André Lindhjem, Kjetil Holien, Terje Risa & Øyvind Nerbråten
 * \date 15.02.2006
 *
 * An interface against libao
 */

#ifndef __daisylibao_H
#define __daisylibao_H


/**
 * includes
 */
#include <mad.h>
#include <stdbool.h>

#include "audio.h"
#include "common.h"


/**
 * This will initialise the libao-part of the engine.
 * Must be called before the libao-part is to be used.
 */
//bool libao_init (struct mad_header const *header,
//				 struct mad_pcm *pcm);
bool libao_init (int byte_format, int channels, int samplerate);

/**
 * This will output samples from a buffer. It basically wraps the ao_play() function.
 */
int libao_play (void *output_samples, int num_bytes);


/**
 * Closes the libao-part the Proper Way [tm]
 */
void libao_close ();


/**
 * Checks if device is null (uninitialized)
 */
bool ao_device_is_null ();


#endif //__daisylibao_H
